==========================================================CLUSTERING MongoDB=======================================================================

1) Buat repository mongodb di masing masing node:

nano /etc/yum.repos.d/mongodb-org.repo

2) isi file mongodb-org.repo di masing masing node dengan repo sebagai berikut:

[mongodb-org-4.0]
name=MongoDB Repository
baseurl=https://repo.mongodb.org/yum/redhat/$releasever/mongodb-org/4.0/x86_64/
gpgcheck=1
enabled=1
gpgkey=https://www.mongodb.org/static/pgp/server-4.0.asc

3) save lalu lakukan proses update repository

yum update -y

jika sudah masuk ke tahap 4

4) install mongodb di masing masing node

yum install mongodb-org -y

jika proses selesai cek stsatus service pada mongo di 3 node tersebut jika status service mongo runing stop service mongo
untuk ke tahap configurasi mongo.conf.

6) configurasi mongodb di ke tiga node

vi /etc/mongod.conf

lalu edit & tambahkan config sebagai berikut:
bindIp: 0.0.0.0
replication:
  replSetName: rsNamaprogram

7) run service mongo di ke tiga node

service mongod start

8) masuk ke mongo di node 1

ketikan=>  mongo

9) ketika perintah sebagai berikut

rs.initiate()
rs.add("oreokuponpromo2")
rs.add("oreokuponpromo3	")
rs.status() 	<== untuk melihat status replicasi benar atau tidak (NOTE:jika node pertama adalah primary maka node 2 dan node 3 adalah secondary)

10) testing replication

use tesdb
show dbs
db.tescollection.insert({"Name" : "Kipli"})


11) enable status replication di node 2 dan 3 sebagai secondary

rs.slaveOk()
use tesdb
show collections ==> maka akan muncul database yang telah kita buat di node 1
db.tescollection.fine() ==> untuk menampilkan hasil insert data dari node 1

12) create user dan password 

use admin

db.createUser(
  {
    user: "oreo",
    pwd: "db-R3dB0x-0r3o-DEV",
    roles: [ { role: "readWrite", db: "oreodb" } ]
  }
)

db.createUser(
	{
	  user:"admin",
	  pwd: "password123"
	  roles: [ { roles: "userAdminAnyDatabases", db: "admin"} ]
	}
    )

13) config file config mongod

 vi /etc/mongod.conf
 hidupkan & tambahkan security

 security:
     authorization: "enabled"

14) lalu restatart service mongo

service mongod restart

15) masuk ke mongo
 
use admin
db.auth("user yang sudah di buat ","password yang sudah di buat");

15) buat prymery kembali ke node 1	

cfg = rs.conf()
cfg.members[0].priority = 1
cfg.members[1].priority = 0.5
cfg.members[2].priority = 0.5
rs.reconfig(cfg)

db.adminCommand({replSetStepDown:1000000, force:1})      <== 1000000 adalah 10 detik

finish

db.User.insert({idUser: "1", name: "KIPLI", Status: "Bocah Ora Tapi Anu"})


oreo
db.auth("oreo", "db-R3dB0x-0r3o-DEV")
db.auth("admin", "dB-R3dB0x2021-0R3o")

yum remove mongodb*
yum clean all
yum install mongodb-org


openssl rand -base64 756 > .mongo.key
		chmod 400 /opt/mongo/.mongo.key
chown mongod:mongod /opt/mongo/.mongo.key


password root server = R3dB0x2021-0R3o
password adminmongo = dB-R3dB0x2021-0R3o
password mongo 	= L1v3-R3dB0x2021-0R3o
password mariadb = L1v3-R3dB0x2021-0R3o
		
